﻿''' <summary>
''' Sample program demonstrating the pulling of Case Notificaiton messages using Web Services.
''' </summary>
''' <remarks></remarks>
Public Class PullCaseNotification
    Const USER_NAME As String = "Your Account"
    Const PASSWORD As String = "Your Password"


    Shared Sub Main()

        'Pull any available case notifications.
        PullCaseNotifications()
    End Sub


    Shared Sub PullCaseNotifications()
        '
        'Pull all available response messages with the retrieval code "MyComplaints".   This only can be used if submissions used the HoldResponse header.
        '
        Dim intRemainingResponses As Integer = 1
        Dim intPulledCount As Integer

        '
        'Connect to the service
        '
        Dim objSVC As New CaseNotificationService.CaseNotificationService_3_6Client("CaseNotificationService_3_3_cu")
        '
        'Setup the security token
        '
        objSVC.ClientCredentials.UserName.UserName = USER_NAME
        objSVC.ClientCredentials.UserName.Password = PASSWORD

        Dim objPullReply As CaseNotificationService.PullReplyXml = Nothing
        Dim objResopnseXmlElement As System.Xml.XmlElement

        'Create the request message
        Dim objPullRequest As New CaseNotificationService.PullRequestXml
        objPullRequest.RetrievalCode = "MyBondNotifications" ' Use the value that was configured with your subscription.



        While intRemainingResponses > 0

            'Call the pull method to get the next available message.
            objPullReply = objSVC.PullHeldCaseNotification(objPullRequest)
            intRemainingResponses = objPullReply.RemainingMessagesCount
            intPulledCount = objPullReply.MessagePulledCount

            If intPulledCount >= 8 Then
                'For some reason the same message has been pulled 8 or more times without being released.
                'Someone should look at this (8 chosen as an example)
                'You will want to log this message somewhere so it can be looked at.
                'For now just release the message so the next message can be pulled.
                ReleaseResponse(objPullReply)
            Else
                'Check if a message was returned.   If it was then process it.
                If Not objPullReply.MessageXml Is Nothing Then
                    'Process the response.   Item could be a Fault or an AttorneyAssignmenttResponse

                    'Do something with the message
                    objResopnseXmlElement = objPullReply.MessageXml

                    'After processing the message release it so the next pull will get the next available message
                    ReleaseResponse(objPullReply)
                End If
            End If
        End While



    End Sub

    Shared Sub ReleaseResponse(ByVal aobjPullReply As CaseNotificationService.PullReplyXml)
        '
        'Connect to the service
        '
        Dim objSVC As New CaseNotificationService.CaseNotificationService_3_6Client("CaseNotificationService_3_3_cu")
        '
        'Setup the security token
        '
        objSVC.ClientCredentials.UserName.UserName = USER_NAME
        objSVC.ClientCredentials.UserName.Password = PASSWORD

        Dim objReleaseReply As CaseNotificationService.ReleaseReplyXml

        'Create the release request message
        Dim objReleaseRequest As New CaseNotificationService.ReleaseRequestXml
        objReleaseRequest.MessageID = aobjPullReply.MessageID
        objReleaseRequest.messageProducedDateTime = Now
        objReleaseRequest.messageProducedDateTimeSpecified = True


        'Call the release method to delete the message that has been pulled, and to make the next available to pull.
        objReleaseReply = objSVC.ReleaseHeldCaseNotification(objReleaseRequest)


    End Sub



End Class
